package com.example.prm02

import android.content.ContentProvider
import android.content.ContentUris
import android.content.ContentValues
import android.content.UriMatcher
import android.database.Cursor
import android.net.Uri

class DebtorProvider:ContentProvider() {
    private val uriMatcher = UriMatcher(UriMatcher.NO_MATCH).apply {
        addURI("com.example.prm02", "debtor", 1)
        addURI("com.example.prm02", "debtor/#", 2)
    }

    override fun onCreate(): Boolean {
        return true
    }

    override fun getType(uri: Uri): String? = when(uriMatcher.match(uri)) {
        1 -> "vnd.android.cursor.dir/vnd.com.example.prm02.debtor"
        2 -> "vnd.android.cursor.item/vnd.com.example.prm02.debtor"
        else -> throw IllegalArgumentException()
    }

    override fun query(
        uri: Uri,
        projection: Array<out String>?,
        selection: String?,
        selectionArgs: Array<out String>?,
        sortOrder: String?
    ): Cursor? {
        val db = context?.applicationContext?.let {
            DbHelper(context).readableDatabase
        } ?: throw RuntimeException("Cannot get application context")

        return when (uriMatcher.match(uri)) {
            1 -> db.query(
                    DbContract.DebtorEntry.TABLE_NAME,
                    projection,
                    selection,
                    selectionArgs,
                    null,
                    null,
                    null
            )
            2 -> {
                val debtorId = ContentUris.parseId(uri)
                db.query(
                    DbContract.DebtorEntry.TABLE_NAME,
                    projection,
                    DbContract.DebtorEntry.COLUMN_ID + " LIKE ? ",
                    arrayOf(debtorId.toString() ),
                    null,
                    null,
                    null)
            }
            else -> throw IllegalArgumentException()
        }
    }

    override fun insert(uri: Uri, values: ContentValues?): Uri? {
        throw NotImplementedError()
    }

    override fun update(
        uri: Uri,
        values: ContentValues?,
        selection: String?,
        selectionArgs: Array<out String>?
    ): Int {
        throw NotImplementedError()
    }

    override fun delete(uri: Uri, selection: String?, selectionArgs: Array<out String>?): Int {
        throw NotImplementedError()
    }

}