package com.example.prm02

import android.app.Activity
import android.content.Intent
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.util.Log
import androidx.recyclerview.widget.LinearLayoutManager
import kotlinx.android.synthetic.main.activity_main.*

class MainActivity : AppCompatActivity(), IRefreshable {

    lateinit var dbHelper: DbHelper
    private val debtorsListAdapter = DebtorListAdapter(this, this)
    lateinit var debtors:ArrayList<Debtor>

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_main)

        dbHelper = DbHelper(this)

        setupRecyclerView(dbHelper)

        fab.setOnClickListener {
            val addDebtor = Intent(this, AddDebtorActivity::class.java)
            addDebtor.putExtra("ifUpdatable", false)
            startActivityForResult(addDebtor, 1)
        }
    }

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)

        if (resultCode == Activity.RESULT_OK) {
            debtorsListAdapter.setDebtors(DataManager.fetchAllDebtors(dbHelper))
        }
    }

    override fun onResume() {
        refreshDebtTotal()
        super.onResume()
    }

    override fun refreshDebtTotal() {
        var refreshedSum = DataManager.fetchAllDebtors(dbHelper).sumByDouble { it.debt.toString().toDouble() }
        Log.i("########################  sum  ##############################", refreshedSum.toString() )
        tvDebtSum.setText(refreshedSum.toString() )
    }

    fun setupRecyclerView(dbHelper: DbHelper){
        recyclerView.adapter = debtorsListAdapter
        recyclerView.layoutManager = LinearLayoutManager(this)
        debtors = DataManager.fetchAllDebtors(dbHelper)
        debtorsListAdapter.setDebtors(debtors)

        var sum = debtors.sumByDouble { it.debt.toDouble() }
        tvDebtSum.setText(sum.toString() )
    }

}
