package com.example.prm02

import android.app.AlertDialog
import android.graphics.Color
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.util.Log
import android.widget.Toast
import kotlinx.android.synthetic.main.activity_add_debtor.*
import kotlinx.android.synthetic.main.activity_simulate_debtor.*
import kotlinx.android.synthetic.main.item_debtor.*
import kotlin.concurrent.thread
import kotlin.math.round

class SimulateDebtorActivity : AppCompatActivity() {
    private lateinit var dbHelper: DbHelper
    var debtorId: Int? = null
    var sem:Boolean = true
    var marker:Boolean = true

    var cInterest:Double = 0.0
    var sInterest:Double = 0.0

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_simulate_debtor)

        dbHelper = DbHelper(this)

        val bundle:Bundle? = intent.extras

        bundle?.let {
            debtorId = bundle.getInt(DbContract.DebtorEntry.COLUMN_ID)

            val debtor = DataManager.fetchDebtor(dbHelper, debtorId!!)

            debtor?.let {
                tvSimName.setText(debtor.name)
                tvSimDebt.setText(debtor.debt)
            }

            bStart.setOnClickListener{
                startSimulation()
            }

            bStop.setOnClickListener{
                stopSimulation()
            }
        }
    }

    private fun stopSimulation() {
        sem = false
    }

    private fun startSimulation() {

        var isValid = true
        val pattern = "[0-9]+((\\.[0-9]+)|())".toRegex()

        etSpeed.error = if (!pattern.matches(etSpeed?.text.toString())) {
            isValid = false
            "Not valid value"
        } else null

        etRate.error = if (!pattern.matches(etRate?.text.toString())) {
            isValid = false
            "Not valid value"
        } else null

        if (isValid) {
//####################################################################################################

            sem = true
            marker = true

            var speed = etSpeed.text.toString().toDouble()
            var rate = etRate.text.toString().toDouble() / 100
            var debtVal = tvSimDebt.text.toString().toDouble()

            val builder = AlertDialog.Builder(this)

            thread {
                while (debtVal > 0.00  && marker ) {
                    if (!sem) {
//                        runOnUiThread() {
//                            tvSimDebt.setText(debtVal.round(4).toString())
//                            tvInterestSum.setText(sInterest.round(4).toString())
//
//                            builder.setMessage("Total interest: ${sInterest.round(4).toString()} ")
//                                .setNegativeButton("ok") { dialog, id ->
//                                    dialog.dismiss()
//                                }
//                            val dialog = builder.create()
//                            dialog.setTitle("Interests")
//                            dialog.show()
//
                        marker = false
//                        }
//                        break
                    }
                    if (marker) {
                        if ((debtVal - speed) >= 0.00) {

//                        Log.i()
                            debtVal = debtVal - speed
                            cInterest = debtVal * rate
                            sInterest = sInterest + cInterest
                            debtVal = debtVal + cInterest
                        } else {
                            debtVal = 0.0
                        }
                    }

                    runOnUiThread {
                        Log.i("else", debtVal.toString())
                        tvSimDebt.setText(debtVal.round(4).toString())
                        tvInterestSum.setText(sInterest.round(4).toString())

                        if (debtVal <= 0.00 || !sem)
                        {
                            builder.setMessage("Total interest: ${sInterest.round(4).toString()} ")
                                .setNegativeButton("ok")
                                {
                                        dialog, id ->
                                    dialog.dismiss()
                                }
                            val dialog = builder.create()
                            dialog.setTitle("Interests")
                            dialog.show()
                        }
                    }

                    Thread.sleep(1000)
                }
            }

//####################################################################################################
        }

        if (!isValid) {
            var t = Toast.makeText(
                applicationContext,
                "Error: incorrect numbers",
                Toast.LENGTH_SHORT
            )
            t.view.setBackgroundColor(Color.RED)
            t.show()
        }
    }


    fun Double.round(decimals: Int): Double {
        var multiplier = 1.0
        repeat(decimals) { multiplier *= 10 }
        return round(this * multiplier) / multiplier
    }


}
